#!/usr/bin/env python

#[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[[
##################################}@{
#
#	EMI(C)2003-2004 FLB STUDIO 2K4
#	Autor : F?lix Le Blanc Mtl
#
##################################}@{
#
#	Function library "COLOR_FADER":
#
#		Class RGBGETSHADOW([r,g,b]) : return rgb shadow
#		Class RGBGETDARKSHADOW([r,g,b]) : return rgb dark shadow
#		Class RGBGETVERYDARKSHADOW([r,g,b]) : return rgb very dark shadow
#		Class RGBGETLIGHT([r,g,b]) : return rgb light
#		Class RGBGETHIGHLIGHT([r,g,b]) : return rgb high light
#		Class RGBGETVERYHIGHLIGHT([r,g,b]) : return rgb very high light
#		Class RGB2RGB([r,g,b],[r,g,b],int) : return rgb tables list from rgb to rgb
#		Class RGB2STR([r,g,b]) : return rgb convertion to hexadecimal string color "#RRGGBB"
#
##################################}@{
#]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]]


def RGBGETSHADOW(t):
	RGB = [0]*len(t)
	for i in range(len(t)):
		RGB[i]=t[i]-10
		if RGB[i] < 0:
			RGB[i]=0
	return RGB

def RGBGETDARKSHADOW(t):
	RGB = [0]*len(t)
	for i in range(len(t)):
		RGB[i]=t[i]-25
		if RGB[i] < 0:
			RGB[i]=0
	return RGB
def RGBGETVERYDARKSHADOW(t):
	RGB = [0]*len(t)
	for i in range(len(t)):
		RGB[i]=t[i]-50
		if RGB[i] < 0:
			RGB[i]=0
	return RGB
def RGBGETLIGHT(t):
	RGB = [0]*len(t)
	for i in range(len(t)):
		RGB[i]=t[i]+10
		if RGB[i] > 255:
			RGB[i]=255
	return RGB

def RGBGETHIGHLIGHT(t):
	RGB = [0]*len(t)
	for i in range(len(t)):
		RGB[i]=t[i]+25
		if RGB[i] > 255:
			RGB[i]=255
	return RGB
def RGBGETVERYHIGHLIGHT(t):
	RGB = [0]*len(t)
	for i in range(len(t)):
		RGB[i]=t[i]+50
		if RGB[i] > 255:
			RGB[i]=255
	return RGB
def  RGB2RGB(A=None,B=None,X=None):
	colorFade = [0]*X
	RGB = [(A[0],B[0]),(A[1],B[1]),(A[2],B[2])]
	steps = [0.0,0.0,0.0]
	add=[0,0,0]
	for i in range(3):
		if RGB[i][0] > RGB[i][1]:
			steps[i]= float(RGB[i][0] - RGB[i][1]) / X
			add[i]=0
		else:
			steps[i]= float(RGB[i][1] - RGB[i][0]) / X
			add[i]=1
	tmp = [RGB[0][0],RGB[1][0],RGB[2][0]]
	for i in range(X):
		c=i
		if add[0] == 1:
			tmp[0]=tmp[0]+steps[0]
		elif add[0] ==0:
			tmp[0]=tmp[0]-steps[0]
		if add[1] == 1:
			tmp[1]=tmp[1]+steps[1]
		elif add[1] ==0:
			tmp[1]=tmp[1]-steps[1]
		if add[2] == 1:
			tmp[2]=tmp[2]+steps[2]
		elif add[2] ==0:
			tmp[2]=tmp[2]-steps[2]
		colorFade[i]=(int(tmp[0]),int(tmp[1]),int(tmp[2]))
	colorFade[(X-1)] = (RGB[0][1],RGB[1][1],RGB[2][1])
	colorFade[0] = (RGB[0][0],RGB[1][0],RGB[2][0])
	return colorFade

def RGB2STR(t):
	color = "#%02X%02X%02X" % tuple(t)
	return color

if __name__=="__main__":
	from Tkinter import *
	root=Tk()
	root.title("CLASS_COLOR_FADER")
	M=1000

	c=RGB2RGB([0,255,0],[0,0,255],M)
	canvas=Canvas(root,width=M,height=100,bg="#000000")
	for i in range(M):
		color = RGB2STR(c[i])
		canvas.create_line(i,50,i,100,fill=color)
		canvas.create_line(M-i+100,0,M-i+100,50,fill=color)
		canvas.create_arc(0,0,100,100,start=i,extent=1,fill=color,outline=color,style=PIESLICE)
	canvas.pack(side=LEFT)
	root.mainloop()
